<template>
  <div div="user">
    <b-jumbotron>
      <template
        slot="header"
      >{{ $route.params.userName ? ('Editing user ' + $route.params.userName) : 'New user' }}</template>

      <div>
        <b-alert :show="hasError" dismissible variant="danger">{{ alertMessage }}</b-alert>
      </div>
      <b-form @submit.stop.prevent="onSubmit">
        <b-form-group
          id="name-input-group"
          label="Name"
          label-for="name-input"
          v-if="!$route.params.userName"
        >
          <b-form-input
            id="name-input"
            name="name-input"
            v-model="$v.form.name.$model"
            :state="$v.form.name.$dirty ? !$v.form.name.$error : null"
            aria-describedby="name-input-live-feedback"
            v-if="!$route.params.userName"
          ></b-form-input>

          <b-form-invalid-feedback id="name-input-live-feedback">Name should not 4 or more symbols.</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group id="password-input-group" label="Password" label-for="name-input">
          <b-form-input
            id="password-input"
            name="password-input"
            v-model="$v.form.password.$model"
            :state="$v.form.password.$dirty ? !$v.form.password.$error : null"
            aria-describedby="name-input-live-feedback"
          ></b-form-input>

          <b-form-invalid-feedback
            id="name-input-live-feedback"
          >Password should not 8 or more symbols.</b-form-invalid-feedback>
        </b-form-group>

        <b-form-group id="groups-input-group" label="Role" label-for="groups-input">
          <label class="typo__label">Select single value</label>
          <multiselect
            v-model="form.role"
            :options="roles"
            :multiple="false"
            :searchable="true"
            :close-on-select="false"
            :show-labels="false"
            :clear-on-select="false"
            :preserve-search="true"
            placeholder="Pick role"
            :preselect-first="false"
          >
            <template slot="selection" slot-scope="{ values, search, isOpen }">
              <span class="multiselect__single" v-if="form.role && !isOpen">selected</span>
            </template>
          </multiselect>
          <!--  -->
        </b-form-group>

        <b-form-group id="groups-input-group" label="Department" label-for="groups-input">
          <label class="typo__label">Select single value</label>
          <multiselect
            v-model="form.unit"
            :options="departments"
            :multiple="false"
            :searchable="true"
            :close-on-select="false"
            :show-labels="false"
            :clear-on-select="false"
            :preserve-search="true"
            placeholder="Pick departmant"
            :preselect-first="false"
          >
            <template slot="selection" slot-scope="{ values, search, isOpen }">
              <span class="multiselect__single" v-if="form.role && !isOpen">selected</span>
            </template>
          </multiselect>
          <!--  -->
        </b-form-group>

        <b-button type="submit" variant="primary" :disabled="$v.form.$invalid">Submit</b-button>
      </b-form>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";
import { validationMixin } from "vuelidate";
import Multiselect from "vue-multiselect";
import { required, minLength } from "vuelidate/lib/validators";

export default {
  name: "NewOrderList",
  components: { Multiselect },
  mixins: [validationMixin],
  mounted() {
    this.loadDepts();
    this.loadUser(this.$route.params.userName);
  },
  beforeRouteUpdate(to, _, next) {
    this.loadDepts();
    this.loadUser(to.params.userName);
    next();
  },
  data() {
    return {
      departments: [],
      roles: ["InstituteManager", "DepartmentManager"],
      isDisabled: false,
      isTouched: false,
      isLoading: true,
      form: {
        name: null,
        password: null,
        unit: null,
        role: null
      },
      alertMessage: "Request error",
      hasError: false
    };
  },
  validations: {
    form: {
      name: {
        required,
        minLength: minLength(4)
      },
      password: {
        required,
        minLength: minLength(8)
      }
    }
  },
  computed: {
    isInvalid() {
      return this.isTouched && this.form.departments.length === 0;
    }
  },
  methods: {
    limitText(count) {
      return `and ${count} other countries`;
    },
    onChange(value) {
      this.value = value;
      if (value.indexOf("Reset me!") !== -1) this.value = [];
    },
    onSelect(option) {
      if (option === "Disable me!") this.isDisabled = true;
    },
    onTouch() {
      this.isTouched = true;
    },
    postData() {
      var path = "/admin/users/update";
      if (!this.$route.params.userName) {
        path = "/admin/users/create";
      }
      AXIOS.post(
        path,
        {
          user: {
            name: this.$data.form.name,
            unit: this.$data.form.unit,
            role: this.$data.form.role
          },
          password: this.$data.form.password
        },
        {
          withCredentials: true
        }
      )
        .then(
          response => {
            console.log(response);
            this.hasError = false;
            this.$router.push({ name: "AdminPage" });
          },
          error => {
            this.$data.alertMessage = error.response.data;
            console.log(this.$data.alertMessage, this.$data.form);
            if (this.$data.alertMessage.search("400") == 0) {
              if (!this.$data.form.unit && this.$data.form.role === null) {
                this.$data.alertMessage = "400: Missing department and role";
              } else if (this.$data.form.role === null) {
                this.$data.alertMessage = "400: Missing role";
              } else if (
                this.$data.form.unit === undefined ||
                this.$data.form.unit === null
              ) {
                this.$data.alertMessage = "400: Missing department";
              }
            }
            this.hasError = true;
            console.log(error);
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.hasError = true;
        });
    },
    async loadUser(userName) {
      if (userName == null) {
        this.$data.form.name = null;
        return null;
      }
      let res = await AXIOS.get("/admin/users", {})
        .then(
          response => {
            console.log(response);
            var target = null;
            response.data.forEach(user => {
              if (user.name === userName) {
                target = {
                  name: user.name,
                  role: user.role,
                  unit: user.unit,
                  password: null
                };
              }
            });
            if (target === null) {
              this.$data.form = {
                name: null,
                password: null,
                unit: null,
                role: null
              };
              this.$data.alertMessage = `404: User ${userName} is not found`;
              this.hasError = true;
            } else {
              this.$data.form = target;
              this.hasError = false;
            }
            return this.$data.form;
          },
          error => {
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            this.$data.form = {
              name: null,
              password: null,
              unit: null,
              role: null
            };
            console.log(error);
          }
        )
        .catch(e => {
          console.log(e);
          this.$data.alertMessage =
            "Server error. Please, report this error website owners";
          this.student = {
            name: null,
            password: null,
            unit: null,
            role: null
          };
          this.hasError = true;
        });
      console.log(res);
    },
    loadDepts() {
      AXIOS.get(`/edu/depts`, {})
        .then(
          response => {
            console.log(response);
            this.departments = response.data;
            this.hasError = false;
          },
          error => {
            console.log(error);
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            this.groups = [];
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.groups = [];
          this.hasError = true;
        });
    },
    onSubmit() {
      this.$v.form.$touch();
      if (this.$v.form.$anyError) {
        console.log(this.$v.form);
        console.log(this.$data.form);
        return;
      }

      this.postData();
    }
  }
};
</script>

<style src="vue-multiselect/dist/vue-multiselect.min.css"></style>